package accumulator;

import java.awt.event.ActionListener;
import javax.swing.JOptionPane;

/**
 * SwingView is a Swing GUI for the Accumulator.
 * @author jdalbey
 */
public class SwingView extends javax.swing.JFrame implements ActionListener
{
    // The current total in the accumulator
    private int total;

    /** Creates new form SwingView */
    public SwingView()
    {
        super("Calc");
        initComponents();
        total = 0;
        /* Use setName() so UISpec can find these components easily */
        txtEntry.setName("Entry");
        btnPlus.setName("Plus");
        btnMinus.setName("Minus");
        txtResult.setName("Result");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        txtEntry = new javax.swing.JTextField();
        btnPlus = new javax.swing.JButton();
        btnMinus = new javax.swing.JButton();
        lblTotal = new javax.swing.JLabel();
        txtResult = new javax.swing.JTextField();
        menuBar = new javax.swing.JMenuBar();
        mnuFile = new javax.swing.JMenu();
        mnuHelp = new javax.swing.JMenu();
        mnuItemAbout = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        txtEntry.setText("0");

        btnPlus.setText("+");
        btnPlus.addActionListener(this);

        btnMinus.setText("-");
        btnMinus.addActionListener(this);

        lblTotal.setText("Total:");

        txtResult.setEditable(false);
        txtResult.setText("0");

        mnuFile.setText("File");
        menuBar.add(mnuFile);

        mnuHelp.setText("Help");

        mnuItemAbout.setText("About");
        mnuItemAbout.addActionListener(this);
        mnuHelp.add(mnuItemAbout);

        menuBar.add(mnuHelp);

        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(txtEntry, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(btnPlus, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(lblTotal, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(btnMinus, javax.swing.GroupLayout.DEFAULT_SIZE, 48, Short.MAX_VALUE)
                            .addComponent(txtResult, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 48, Short.MAX_VALUE))))
                .addGap(22, 22, 22))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(txtEntry, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnPlus)
                    .addComponent(btnMinus))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblTotal)
                    .addComponent(txtResult, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }

    // Code for dispatching events from components to event handlers.

    public void actionPerformed(java.awt.event.ActionEvent evt) {
        if (evt.getSource() == btnPlus) {
            SwingView.this.btnPlusActionPerformed(evt);
        }
        else if (evt.getSource() == btnMinus) {
            SwingView.this.btnMinusActionPerformed(evt);
        }
        else if (evt.getSource() == mnuItemAbout) {
            SwingView.this.mnuItemAboutActionPerformed(evt);
        }
    }// </editor-fold>//GEN-END:initComponents

    private void btnPlusActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnPlusActionPerformed
    {//GEN-HEADEREND:event_btnPlusActionPerformed
        int value = Integer.parseInt(txtEntry.getText());
        total = total + value;
        refresh();
    }//GEN-LAST:event_btnPlusActionPerformed

    private void btnMinusActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnMinusActionPerformed
    {//GEN-HEADEREND:event_btnMinusActionPerformed
        int value = Integer.parseInt(txtEntry.getText());
        total = total - value;
        refresh();
    }//GEN-LAST:event_btnMinusActionPerformed

    private void mnuItemAboutActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_mnuItemAboutActionPerformed
    {//GEN-HEADEREND:event_mnuItemAboutActionPerformed
        JOptionPane.showMessageDialog(this, "The About message will appear here.");
    }//GEN-LAST:event_mnuItemAboutActionPerformed

    private void refresh()
    {
        txtResult.setText("" + total);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnMinus;
    private javax.swing.JButton btnPlus;
    private javax.swing.JLabel lblTotal;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenu mnuFile;
    private javax.swing.JMenu mnuHelp;
    private javax.swing.JMenuItem mnuItemAbout;
    private javax.swing.JTextField txtEntry;
    private javax.swing.JTextField txtResult;
    // End of variables declaration//GEN-END:variables
}
