package accumulator;

import junit.framework.TestCase;
import org.uispec4j.*;
import org.uispec4j.interception.*;

/**
 * The UISpec4J test of the entire app.
 * It extends UISpecTestCase, not JUnit TestCase
 * It uses special UISpec-style asserts.
 * It instantiates the application main method.
 * @author jdalbey
 */
public class AppTest extends UISpecTestCase
{
    public AppTest(String testName)
    {
        super(testName);
    }

    protected void setUp() throws Exception
    {
        setAdapter(new MainClassAdapter(Main.class, new String[0]));
    }

    public void testAdd()
    {
        Window mainWindow = getMainWindow();
        /* Note: Window, TextBox, and Button are UISpec4J classes */
        assertTrue(mainWindow.titleEquals("Calc"));
        TextBox entry = mainWindow.getInputTextBox("Entry");
        entry.appendText("5");
        Button plus = mainWindow.getButton("Plus");
        plus.click();
        TextBox result = mainWindow.getTextBox("Result");
        // UISpec-style assert
        assertTrue(result.textEquals("5"));
    }
}
