package accumulator;

import junit.framework.TestCase;
import org.uispec4j.*;

/**
 * The normal kind of UISpec4J test.
 * It extends UISpecTestCase, not JUnit TestCase
 * It uses special UISpec-style asserts.
 * It instantiates just a single GUI frame; it doesn't run
 * the application main method.
 * @author jdalbey
 */
public class NormalTest extends UISpecTestCase
{
    public NormalTest(String testName)
    {
        super(testName);
    }

    public void testAdd()
    {
        SwingView view = new SwingView();
        /* Note: Window, TextBox, and Button are UISpec4J classes */
        Window win = new Window(view);
        assertTrue(win.titleEquals("Calc"));
        TextBox entry = win.getInputTextBox("Entry");
        entry.appendText("5");
        Button plus = win.getButton("Plus");
        plus.click();
        TextBox result = win.getTextBox("Result");
        // UISpec-style assert
        assertTrue(result.textEquals("5"));       
    }
}
