package accumulator;

import java.awt.event.ActionEvent;
import junit.framework.TestCase;
import org.uispec4j.*;
import org.uispec4j.interception.*;

/**
 * This demonstrates using UISpec4J to test that a popup dialog appears correctly.
 * @author jdalbey
 */
public class PopupTest extends TestCase
{
    public PopupTest(String testName)
    {
        super(testName);
    }

    /* This is needed for the next test, otherwise the dialog is displayed 
    instead of being intercepted by UISpec */
    static
    {
        UISpec4J.init();
    }

    public void testAbout()
    {
        SwingView view = new SwingView();
        Window win = new Window(view);
        // Select About from the Help menu and
        // Check that the About box displays properly
        WindowInterceptor.init(win.getMenuBar().getMenu("Help").getSubMenu(
                "About").triggerClick()).
                process(BasicHandler.init().
                assertContainsText("About").
                triggerButtonClick("OK")).run();
    }
}
