package accumulator;

import junit.framework.TestCase;
import org.uispec4j.*;

/**
 * The simplest kind of UISpec4J test.
 * It extends JUnit TestCase, not UISpecTestCase.
 * Therefore, it uses standard JUnit-style asserts,
 *  not the UISpec-style.
 * It instantiates just a single GUI frame; it doesn't run
 * the application main method.
 * @author jdalbey
 */
public class SimplestTest extends TestCase
{
    public SimplestTest(String testName)
    {
        super(testName);
    }

    public void testAdd()
    {
        SwingView view = new SwingView();
        /* Note: Window, TextBox, and Button are UISpec4J classes */
        Window win = new Window(view);
        TextBox entry = win.getInputTextBox("Entry");
        entry.appendText("5");
        Button plus = win.getButton("Plus");
        plus.click();
        TextBox result = win.getTextBox("Result");
        /* Standard JUnit assert */
        assertEquals("5", result.getText());
    }
}
